## pixelmed-codec 20141206

=== Makefile ===
all:	pixelmed_codec.jar

TAR = gnutar
#TAR = tar
COMPRESS = bzip2
COMPRESSEXT = bz2

SUBDIRS = \
	com/pixelmed/codec/jpeg
	
SUBPACKAGES = \
	com.pixelmed.codec.jpeg

ADDITIONALFILES = \
	COPYRIGHT \
	Makefile \
	Makefile.common.mk \
	README

ADDITIONALSOURCEFILES = \
	Doxyfile

BINARYRELEASEFILES = \
	pixelmed_codec.jar \
	BUILDDATE \
	${ADDITIONALFILES}

SOURCERELEASEFILES = \
	${ADDITIONALFILES} \
	${ADDITIONALSOURCEFILES} \
	${SUBDIRS}

DEPENDENCYRELEASEFILESWITHOUTREADME = \
	lib/junit/junit-4.8.1.jar \
	LICENSES

DEPENDENCYRELEASEFILES = \
	${DEPENDENCYRELEASEFILESWITHOUTREADME} \
	README

JAVADOCRELEASEFILES = \
	${JAVADOCFILES}

DOXYGENRELEASEFILES = \
	${DOXYGENFILES}

JAVADOCFILES = \
	docs/javadoc

DOXYGENFILES = \
        docs/doxygen

OTHERDOCRELEASEFILES = \

PATHTOROOT = .

include ${PATHTOROOT}/Makefile.common.mk

pixelmed_codec.jar:
	(cd com/pixelmed/codec/jpeg; make all)
	date >BUILDDATE
	jar -cvf $@ BUILDDATE COPYRIGHT \
		com/pixelmed/codec/jpeg/*.class
changelog:
	rm -f CHANGES
	cvsps -u -q | egrep -v '^(PatchSet|Author:|Branch:|Tag:|Members:|Log:)' | fgrep -v '*** empty log message ***' | grep -v '^[ ]*$$' | sed -e 's/:[0-9.]*->[0-9.]*//' -e 's/:INITIAL->[0-9.]*//' -e 's/^Date: \([0-9][0-9][0-9][0-9]\/[0-9][0-9]\/[0-9][0-9]\) [0-9:]*$$/\1/' >CHANGES
	bzip2 <CHANGES >CHANGES.bz2
	
clean:	cleanallexceptjar
	rm -f pixelmed_codec.jar

cleanallexceptjar:	cleansubdirs
	rm -f *~ *.class .exclude.list

cleansubdirs:
	for d in ${SUBDIRS}; \
	do \
		if [ -d $$d ]; then \
			(cd $$d; echo "Cleaning in $$d"; make clean); \
		fi; \
	done

archivesource: clean .exclude.list
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - Makefile ${ADDITIONALFILES} ${SUBDIRS} | ${COMPRESS} > pixelmedjavacodec_source_archive.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

archivejavadoc: .exclude.list #javadoc
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${JAVADOCFILES} | ${COMPRESS} > pixelmedjavacodec_javadoc_archive.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

archivedoxygen: .exclude.list #doxygen
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${DOXYGENFILES} | ${COMPRESS} > pixelmedjavacodec_javadoc_archive.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

releaseall:	changelog sourcerelease javadocrelease doxygenrelease binaryrelease dependencyrelease otherdocrelease

binaryrelease: cleanallexceptjar .exclude.list pixelmed_codec.jar #javadoc doxygen
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${BINARYRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_binaryrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

otherdocrelease:
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -f - ${OTHERDOCRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_otherdocsrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

dependencyrelease:	.exclude.list
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${DEPENDENCYRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_dependencyrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

sourcerelease: clean .exclude.list #clean javadoc doxygen
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${SOURCERELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_sourcerelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

javadocrelease:  .exclude.list #clean javadoc doxygen
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${JAVADOCRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_javadocrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

doxygenrelease: .exclude.list #clean javadoc doxygen
	export COPYFILE_DISABLE=true; \
	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
	${TAR} -cv -X .exclude.list -f - ${DOXYGENRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_doxygenrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}

.exclude.list:	Makefile
	echo "Making .exclude.list"
	echo ".DS_Store" > $@
	echo ".directory" >> $@
	echo "*.tar.gz" >> $@
	echo "*.tar.bz2" >> $@
	echo "*.tar.bz2" >> $@
	#ls *.jar | grep -v 'pixelmed_codec.jar' >> $@
	echo "cleanerdst.*" >> $@
	echo "cleanersrc.*" >> $@
	#find . -path  '*/cleanerdst.*' | sed 's/[.][/]//' >>$@
	#find . -path  '*/cleanersrc.*' | sed 's/[.][/]//' >>$@
	find . -path '*/NOTES*' | sed 's/[.][/]//' >>$@
	find . -path '*/CVS*' | sed 's/[.][/]//' >>$@
	echo "com/pixelmed/web/favicon.ill" >> $@
	#cat $@

# used to link to "http://www.junit.org/apidocs/" but this no longer works ... use version-specific "http://javasourcecode.org/html/open-source/junit/junit-4.8.1/" instead
javadoc:
	rm -rf docs/javadoc
	javadoc \
		-classpath .:lib/additional/excalibur-bzip2-1.0.jar:lib/additional/hsqldb.jar:lib/additional/vecmath1.2-1.14.jar:lib/additional/commons-codec-1.3.jar:lib/additional/commons-net-ftp-2.0.jar:lib/additional/jmdns.jar:lib/additional/jpedalSTD.jar:lib/junit/junit-4.8.1.jar \
		-link http://download.oracle.com/javase/1.5.0/docs/api/ \
		-link http://jpedal.org/javadoc/ \
		-link http://www.hsqldb.org/doc/src/ \
		-link http://javasourcecode.org/html/open-source/junit/junit-4.8.1/ \
		-protected -d docs/javadoc \
		-encoding "UTF8" \
		${SUBPACKAGES}

doxygen:
	rm -rf docs/doxygen
	doxygen Doxyfile

installinpixelmed:	pixelmed_codec.jar
	cp $< ../pixelmed/imgbook/lib/additional/

=== pixelmed/codec/jpeg/Makefile ===
OBJS = \
	EntropyCodedSegment.class \
	HuffmanTable.class \
	Markers.class \
	MarkerSegmentAPP0JFIF.class \
	MarkerSegmentDHT.class \
	MarkerSegmentDQT.class \
	MarkerSegmentSOF.class \
	MarkerSegmentSOS.class \
	Parse.class \
	QuantizationTable.class \
	Utilities.class

all:	${OBJS}

PATHTOROOT = ../../../..

include ${PATHTOROOT}/Makefile.common.mk

clean:
	rm -f *~ *.class core *.bak

testparse:	${OBJS}
	rm -f /tmp/crap_copied.jpg
	rm -f /tmp/crap_source.jpg
	cp -v \
		"$${HOME}/Documents/Clients/MDDX/Experiment20130905/crap.jpg" \
		/tmp/crap_source.jpg
	java -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
		/tmp/crap_source.jpg \
		/tmp/crap_copied.jpg
	@echo "Comparing source and copied ... may fail with EOF if padding after EOI marker that is not copied, which is OK"
	cmp /tmp/crap_source.jpg /tmp/crap_copied.jpg
	@echo "Finished comparing"
	hexdump -C /tmp/crap_source.jpg | tail -3
	hexdump -C /tmp/crap_copied.jpg | tail -3

# without restart and working
		#"$${HOME}/Documents/Medical/compression/JPEG/10918-1/jpeg-6/testimg.jpg"
		#"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/colorpngresavedfrompreview.jpg"
		#"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/huff_simple0.jpg"
		#"$${HOME}/Documents/Clients/MDDX/Experiment20130905/crap.jpg"
		#"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/smpte_8_q1.jpg"

# without restart and not working

# with restart and working
		#"$${HOME}/Pictures/Interesting/clunie_737_cropped_close.jpg"
		#"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/smpte_8_cjpeg_rst1.jpg"
		#"/tmp/crap.jpg"

# with restart and not working

=== debian/changelog ===
pixelmed-codec (20141206-1) unstable; urgency=low

  * Initial release. (Closes: #808152)

 -- Andreas Tille <tille@debian.org>  Wed, 16 Dec 2015 16:38:12 +0100

=== debian/control ===
Source: pixelmed-codec
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 9)
Build-Depends-Indep: default-jdk,
                     javahelper,
                     junit4,
                     libhsqldb-java
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/pixelmed-codec/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/pixelmed-codec/trunk/
Homepage: http://www.pixelmed.com

Package: libpixelmed-codec-java
Architecture: all
Section: java
Depends: ${java:Depends},
         ${misc:Depends}
Description: some imaging codices for pixelmed DICOM image and ECG viewer
 Pixelmed is a stand-alone DICOM toolkit that implements code for reading
 and creating DICOM data, DICOM network and file support, a database of
 DICOM objects, support for display of directories, images, reports and
 spectra, and DICOM object validation.
 .
 This package contains some file format codecs used by pixelmed but
 provided as a separate tarball.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export JAVA_HOME=/usr/lib/jvm/default-java

VERSION = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f2 -d~)

%:
	dh $@ --with javahelper

#override_dh_auto_build:
#	$(MAKE) all
#	$(MAKE) javadoc

=== debian/watch ===
version=3
http://www.dclunie.com/pixelmed/software/codec/([b\d]+)_current/pixelmedjavacodec_sourcerelease.([\d]+).tar.bz2

## pixelmed-codec 20170512

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-all:	pixelmed_codec.jar
+all:	pixelmed_codec.jar pixelmed_imageio.jar
 
 TAR = gnutar
 #TAR = tar
@@ -6,10 +6,12 @@
 COMPRESSEXT = bz2
 
 SUBDIRS = \
-	com/pixelmed/codec/jpeg
+	com/pixelmed/codec/jpeg \
+	com/pixelmed/imageio
 	
 SUBPACKAGES = \
-	com.pixelmed.codec.jpeg
+	com.pixelmed.codec.jpeg \
+	com.pixelmed.imageio
 
 ADDITIONALFILES = \
 	COPYRIGHT \
@@ -22,6 +24,7 @@
 
 BINARYRELEASEFILES = \
 	pixelmed_codec.jar \
+	pixelmed_imageio.jar \
 	BUILDDATE \
 	${ADDITIONALFILES}
 
@@ -50,27 +53,44 @@
 DOXYGENFILES = \
         docs/doxygen
 
-OTHERDOCRELEASEFILES = \
+#OTHERDOCRELEASEFILES = \
+#
 
 PATHTOROOT = .
 
 include ${PATHTOROOT}/Makefile.common.mk
+
+metainf:
+	mkdir -p META-INF/services
+	rm -f META-INF/services/javax.imageio.spi.ImageReaderSpi
+	echo >META-INF/services/javax.imageio.spi.ImageReaderSpi "com.pixelmed.imageio.JPEGLosslessImageReaderSpi"
 
 pixelmed_codec.jar:
 	(cd com/pixelmed/codec/jpeg; make all)
 	date >BUILDDATE
 	jar -cvf $@ BUILDDATE COPYRIGHT \
 		com/pixelmed/codec/jpeg/*.class
+
+pixelmed_imageio.jar:	metainf
+	(cd com/pixelmed/codec/jpeg; make all)
+	(cd com/pixelmed/imageio; make all)
+	date >BUILDDATE
+	jar -cvf $@ BUILDDATE COPYRIGHT \
+		META-INF/services/javax.imageio.spi.ImageReaderSpi \
+		com/pixelmed/codec/jpeg/*.class \
+		com/pixelmed/imageio/*.class \
+
 changelog:
 	rm -f CHANGES
 	cvsps -u -q | egrep -v '^(PatchSet|Author:|Branch:|Tag:|Members:|Log:)' | fgrep -v '*** empty log message ***' | grep -v '^[ ]*$$' | sed -e 's/:[0-9.]*->[0-9.]*//' -e 's/:INITIAL->[0-9.]*//' -e 's/^Date: \([0-9][0-9][0-9][0-9]\/[0-9][0-9]\/[0-9][0-9]\) [0-9:]*$$/\1/' >CHANGES
 	bzip2 <CHANGES >CHANGES.bz2
 	
 clean:	cleanallexceptjar
-	rm -f pixelmed_codec.jar
+	rm -f pixelmed_codec.jar pixelmed_imageio.jar
 
 cleanallexceptjar:	cleansubdirs
 	rm -f *~ *.class .exclude.list
+	rm -rf META-INF
 
 cleansubdirs:
 	for d in ${SUBDIRS}; \
@@ -95,17 +115,18 @@
 	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
 	${TAR} -cv -X .exclude.list -f - ${DOXYGENFILES} | ${COMPRESS} > pixelmedjavacodec_javadoc_archive.`date '+%Y%m%d'`.tar.${COMPRESSEXT}
 
-releaseall:	changelog sourcerelease javadocrelease doxygenrelease binaryrelease dependencyrelease otherdocrelease
+#releaseall:	changelog sourcerelease javadocrelease doxygenrelease binaryrelease dependencyrelease otherdocrelease
+releaseall:	changelog sourcerelease javadocrelease doxygenrelease binaryrelease dependencyrelease
 
-binaryrelease: cleanallexceptjar .exclude.list pixelmed_codec.jar #javadoc doxygen
+binaryrelease: cleanallexceptjar .exclude.list pixelmed_codec.jar pixelmed_imageio.jar #javadoc doxygen
 	export COPYFILE_DISABLE=true; \
 	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
 	${TAR} -cv -X .exclude.list -f - ${BINARYRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_binaryrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}
 
-otherdocrelease:
-	export COPYFILE_DISABLE=true; \
-	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
-	${TAR} -cv -f - ${OTHERDOCRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_otherdocsrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}
+#otherdocrelease:
+#	export COPYFILE_DISABLE=true; \
+#	export COPY_EXTENDED_ATTRIBUTES_DISABLE=true; \
+#	${TAR} -cv -f - ${OTHERDOCRELEASEFILES} | ${COMPRESS} > pixelmedjavacodec_otherdocsrelease.`date '+%Y%m%d'`.tar.${COMPRESSEXT}
 
 dependencyrelease:	.exclude.list
 	export COPYFILE_DISABLE=true; \
@@ -161,6 +182,7 @@
 	rm -rf docs/doxygen
 	doxygen Doxyfile
 
-installinpixelmed:	pixelmed_codec.jar
-	cp $< ../pixelmed/imgbook/lib/additional/
+installinpixelmed:	pixelmed_codec.jar pixelmed_imageio.jar
+	cp pixelmed_codec.jar ../pixelmed/imgbook/lib/additional/
+	cp pixelmed_imageio.jar ../pixelmed/imgbook/lib/additional/

=== pixelmed/imageio/Makefile ===
OBJS = \
	JPEGLosslessImageReaderSpi.class \
	JPEGLosslessImageReader.class \
	JPEGLosslessMetadata.class \
	JPEGLosslessMetadataFormat.class \
	TestImageIO.class

all:	${OBJS}

PATHTOROOT = ../../..

include ${PATHTOROOT}/Makefile.common.mk

clean:
	rm -f *~ *.class core *.bak

testlosslessjpeg:
	# need to use jar file, since won't find new SPI in classpath without META-INF
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/crap6.jpg jpeg-lossless 0
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/crap6.jpg		# tests JPEGLosslessImageReaderSpi.canDecodeInput() (works irrespective of extension)
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO "$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O1.JPG" jpeg-lossless 0	# 4 components, so will fail
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO "$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O2.JPG" jpeg-lossless 0	# 4 components, so will fail
	#gunzip < "$${HOME}/Pictures/Medical/USFDigitalMammography/USFmammo_cases_partial_fromsite/DDSM/cases/benigns/benign_01/case0029/C_0029_1.LEFT_CC.LJPEG.gz" > /tmp/C_0029_1.LEFT_CC.LJPEG
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/C_0029_1.LEFT_CC.LJPEG jpeg-lossless 0	# uses SV7
	#java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/C_0029_1.LEFT_CC.LJPEG	# tests JPEGLosslessImageReaderSpi.canDecodeInput()
	rm -rf  /tmp/crap.jpg
	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/BadWithPVRGCodecButOKWithOther/000caecb.dcm" /tmp/crap.jpg
	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/BadWithPVRGCodecButOKWithOther/000cb12e.dcm" /tmp/crap.jpg
	dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/EightBitJIIOCodecProblem/seq0" /tmp/crap.jpg
	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/eightbitrgbsingleframe.dcm" /tmp/crap.jpg	# DHT segment between SOI and SOF
	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/ivus_thousandsofframes_losslessjpeg.dcm" /tmp/crap.jpg	# DHT segment between SOI and SOF
	java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/crap.jpg

=== pixelmed/codec/jpeg/Makefile ===
--- 
+++ 
@@ -9,7 +9,8 @@
 	MarkerSegmentSOS.class \
 	Parse.class \
 	QuantizationTable.class \
-	Utilities.class
+	Utilities.class \
+	OutputArrayOrStream.class
 
 all:	${OBJS}
 
@@ -24,12 +25,13 @@
 	rm -f /tmp/crap_copied.jpg
 	rm -f /tmp/crap_source.jpg
 	cp -v \
-		"$${HOME}/Documents/Clients/MDDX/Experiment20130905/crap.jpg" \
+		"/Volumes/Toshiba5TEnc/MDDX/20170320_Assembla2719_MissingJPEGEOI/corruptedfile147652_IM001_35.jpg" \
 		/tmp/crap_source.jpg
-	java -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
+	java -Djava.awt.headless=true  -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
 		/tmp/crap_source.jpg \
 		/tmp/crap_copied.jpg
-	@echo "Comparing source and copied ... may fail with EOF if padding after EOI marker that is not copied, which is OK"
+	# use make -i to continue to dump
+	@echo "Comparing source and copied ... may fail with EOF if padding after EOI marker that is not copied, or missing EOI marker is added, both of which are OK"
 	cmp /tmp/crap_source.jpg /tmp/crap_copied.jpg
 	@echo "Finished comparing"
 	hexdump -C /tmp/crap_source.jpg | tail -3
@@ -45,9 +47,58 @@
 # without restart and not working
 
 # with restart and working
-		#"$${HOME}/Pictures/Interesting/clunie_737_cropped_close.jpg"
+		#"$${HOME}/Pictures/Interesting/Me/clunie_737_cropped_close.jpg"
 		#"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/smpte_8_cjpeg_rst1.jpg"
-		#"/tmp/crap.jpg"
+		#"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process1/A1.JPG"
 
 # with restart and not working
 
+# premature EOF without EOI marker working (Heartlab)
+		# dctoraw "/Volumes/Toshiba5TEnc/MDDX/20160928_CorruptionDuringMasking/dicom File.dcm" "/Volumes/Toshiba5TEnc/MDDX/20160928_CorruptionDuringMasking/dicom File.jpg"
+		# "/Volumes/Toshiba5TEnc/MDDX/20160928_CorruptionDuringMasking/dicom File.jpg"
+
+		# dctoraw "/Volumes/Toshiba5TEnc/MDDX/20170320_Assembla2719_MissingJPEGEOI/corruptedfile147652/corruptedfile147652/IM001(35)" "/Volumes/Toshiba5TEnc/MDDX/20170320_Assembla2719_MissingJPEGEOI/corruptedfile147652_IM001_35.jpg"
+		# "/Volumes/Toshiba5TEnc/MDDX/20170320_Assembla2719_MissingJPEGEOI/corruptedfile147652_IM001_35.jpg"
+
+
+testdecompress:	${OBJS}
+	rm -f /tmp/crap_source.jpg
+	rm -f /tmp/crap_decompressed*.raw
+	cp -v \
+		"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O1.JPG" \
+		/tmp/crap_source.jpg
+	java -Djava.awt.headless=true  -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
+		/tmp/crap_source.jpg \
+		"" \
+		/tmp/crap_decompressed.raw
+	ls -l /tmp/crap_decompressed*.raw
+
+		#"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O1.JPG" \
+		#"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O2.JPG" \
+
+testdecompressfromdicom:	${OBJS}
+	rm -f /tmp/crap_source.dcm
+	rm -f /tmp/crap_source.jpg
+	rm -f /tmp/crap_decompressed*.raw
+	cp -v \
+		"$${HOME}/Pictures/Medical/JPEGVarious/z18" \
+		/tmp/crap_source.dcm
+	dctoraw \
+		/tmp/crap_source.dcm \
+		/tmp/crap_source.jpg
+	java -Djava.awt.headless=true  -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
+		/tmp/crap_source.jpg \
+		"" \
+		/tmp/crap_decompressed.raw
+	ls -l /tmp/crap_decompressed*.raw
+	rm -f /tmp/crap_source_dcunjpeg.*
+	dcunjpeg /tmp/crap_source.dcm /tmp/crap_source_dcunjpeg_little.dcm
+	dccp -endian big -vr explicit /tmp/crap_source_dcunjpeg_little.dcm /tmp/crap_source_dcunjpeg_big.dcm
+	dctoraw /tmp/crap_source_dcunjpeg_big.dcm /tmp/crap_source_dcunjpeg.raw
+	@echo "Comparing decompressed with pixelmed codec and decompressed with whatever codec dcunjpeg uses"
+	cmp /tmp/crap_decompressed.raw /tmp/crap_source_dcunjpeg.raw
+	@echo "Finished comparing"
+	hexdump -C /tmp/crap_decompressed.raw | head -3
+	hexdump -C /tmp/crap_source_dcunjpeg.raw | head -3
+
+		# "$${HOME}/Pictures/Medical/JPEGVarious/z18"

=== debian/changelog ===
pixelmed-codec (20170512-2) unstable; urgency=medium

  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Secure URI in copyright format
  * Remove custom compression settings

 -- Andreas Tille <tille@debian.org>  Tue, 08 Jan 2019 16:16:25 +0100

pixelmed-codec (20170512-1) unstable; urgency=medium

  * New upstream version
  * Move packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Do not set bootclasspath
    Closes: #875779

 -- Andreas Tille <tille@debian.org>  Thu, 14 Sep 2017 18:58:23 +0200

pixelmed-codec (20141206-2) unstable; urgency=medium

  * Make build reproducible (thanks for the patch to Chris Lamb)
    Closes: #834052
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Fri, 12 Aug 2016 15:25:19 +0200

=== debian/control ===
Source: pixelmed-codec
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 11~)
Build-Depends-Indep: default-jdk,
                     javahelper,
                     junit4,
                     libhsqldb-java
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/pixelmed-codec
Vcs-Git: https://salsa.debian.org/med-team/pixelmed-codec.git
Homepage: http://www.pixelmed.com

Package: libpixelmed-codec-java
Architecture: all
Section: java
Depends: ${java:Depends},
         ${misc:Depends}
Description: some imaging codecs for pixelmed DICOM image and ECG viewer
 Pixelmed is a stand-alone DICOM toolkit that implements code for reading
 and creating DICOM data, DICOM network and file support, a database of
 DICOM objects, support for display of directories, images, reports and
 spectra, and DICOM object validation.
 .
 This package contains some file format codecs used by pixelmed but
 provided as a separate tarball.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --with javahelper

## pixelmed-codec 20200328

=== pixelmed/imageio/Makefile ===
--- 
+++ 
@@ -30,3 +30,8 @@
 	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/eightbitrgbsingleframe.dcm" /tmp/crap.jpg	# DHT segment between SOI and SOF
 	#dctoraw "$${HOME}/Pictures/Medical/JPEGLossless/ivus_thousandsofframes_losslessjpeg.dcm" /tmp/crap.jpg	# DHT segment between SOI and SOF
 	java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO /tmp/crap.jpg
+
+testnotlosslessjpeg:
+	# should fail rather than display black image
+	java -cp ${PATHTOROOT}/pixelmed_imageio.jar com.pixelmed.imageio.TestImageIO "${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/smpte_8_q1.jpg" jpeg-lossless 0
+

=== pixelmed/codec/jpeg/Makefile ===
--- 
+++ 
@@ -25,17 +25,19 @@
 	rm -f /tmp/crap_copied.jpg
 	rm -f /tmp/crap_source.jpg
 	cp -v \
-		"/Volumes/Toshiba5TEnc/MDDX/20170320_Assembla2719_MissingJPEGEOI/corruptedfile147652_IM001_35.jpg" \
+		"$${HOME}/Documents/Clients/MDDX/Experiment20130905/crap.jpg" \
 		/tmp/crap_source.jpg
 	java -Djava.awt.headless=true  -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
 		/tmp/crap_source.jpg \
 		/tmp/crap_copied.jpg
 	# use make -i to continue to dump
+	ls -l /tmp/crap_source.jpg
+	ls -l /tmp/crap_copied.jpg
+	hexdump -C /tmp/crap_source.jpg | tail -3
+	hexdump -C /tmp/crap_copied.jpg | tail -3
 	@echo "Comparing source and copied ... may fail with EOF if padding after EOI marker that is not copied, or missing EOI marker is added, both of which are OK"
 	cmp /tmp/crap_source.jpg /tmp/crap_copied.jpg
 	@echo "Finished comparing"
-	hexdump -C /tmp/crap_source.jpg | tail -3
-	hexdump -C /tmp/crap_copied.jpg | tail -3
 
 # without restart and working
 		#"$${HOME}/Documents/Medical/compression/JPEG/10918-1/jpeg-6/testimg.jpg"
@@ -76,6 +78,17 @@
 		#"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O1.JPG" \
 		#"$${HOME}/Documents/Medical/compression/JPEG/10918-2/ITU T83/T83_process14/O2.JPG" \
 
+testcannotdecompress:	${OBJS}
+	rm -f /tmp/crap_source.jpg
+	rm -f /tmp/crap_decompressed*.raw
+	cp -v \
+		"${PATHTOROOT}/${PATHTOTESTFILESFROMROOT}/smpte_8_q1.jpg" \
+		/tmp/crap_source.jpg
+	java -Djava.awt.headless=true  -cp ${PATHTOROOT} com.pixelmed.codec.jpeg.Parse \
+		/tmp/crap_source.jpg \
+		"" \
+		/tmp/crap_decompressed.raw
+
 testdecompressfromdicom:	${OBJS}
 	rm -f /tmp/crap_source.dcm
 	rm -f /tmp/crap_source.jpg

=== debian/changelog ===
pixelmed-codec (20200328-6) unstable; urgency=medium

  * Raising Standards version to 4.6.2 (no change)
  * Marking Debian-specific patches as Forwarded: not-needed
  * Raising source/target versions to comply with OpenJDK-21 (Closes: #1053075)

 -- Pierre Gruet <pgt@debian.org>  Fri, 06 Oct 2023 22:37:51 +0200

pixelmed-codec (20200328-5) unstable; urgency=medium

  * Moving javahelper from B-D-I to B-D so that the clean rule of source
    builds works
  * Setting Standards version to 4.6.1 (no change)
  * Adding myself as uploader
  * Updating years in d/copyright
  * Fixing d/watch to download future versions

 -- Pierre Gruet <pgt@debian.org>  Sun, 02 Oct 2022 14:35:35 +0200

pixelmed-codec (20200328-4) unstable; urgency=medium

  * Enhance watch file to at least check for the latest version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Do not parse d/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Apply multi-arch hints.
    + libpixelmed-codec-java, libpixelmed-imageio-java: Add Multi-Arch: foreign.
  * Build-Depends: help2man

 -- Andreas Tille <tille@debian.org>  Mon, 18 Oct 2021 18:06:20 +0200

pixelmed-codec (20200328-3) unstable; urgency=medium

  [ Chris Lamb ]
  * d/patches: please make the build reproducible. Closes: #968185

  [ Mathieu Malaterre ]
  * Team upload.
  * d/jpegparse Add new command line tool.
  * d/patches: Add patch to handle help2man
  * d/jpegparse.1.in: Add template for help2man
  * d/rules: Build jpegparse man page
  * d/control: Reflect location of new command line tool: jpegparse.
  * d/manpages: Install jpegparse manpage

 -- Mathieu Malaterre <malat@debian.org>  Tue, 18 Aug 2020 11:32:08 +0200

pixelmed-codec (20200328-2) unstable; urgency=medium

  * Team upload.
  * d/control: Add missing pixelmed-imageio jar

 -- Mathieu Malaterre <malat@debian.org>  Wed, 05 Aug 2020 11:31:46 +0200

pixelmed-codec (20200328-1) unstable; urgency=medium

  * Team upload.
  * d/control: Update Homepage to direct location
  * d/copyright: Update Source URL
  * New upstream version 20200328
  * d/control: Bump Std-Vers to 4.5.0; no changes needed
  * d/rules: Remove BUILDDATE file

 -- Mathieu Malaterre <malat@debian.org>  Fri, 31 Jul 2020 10:35:58 +0200

=== debian/control ===
Source: pixelmed-codec
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Pierre Gruet <pgt@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               javahelper
Build-Depends-Indep: default-jdk,
                     junit4,
                     libhsqldb-java,
                     help2man
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/pixelmed-codec
Vcs-Git: https://salsa.debian.org/med-team/pixelmed-codec.git
Homepage: https://www.pixelmed.com/jpeg.html
Rules-Requires-Root: no

Package: libpixelmed-codec-java
Architecture: all
Section: java
Depends: ${java:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: JPEG selective block redaction codec for pixelmed
 Pixelmed is a stand-alone DICOM toolkit that implements code for reading
 and creating DICOM data, DICOM network and file support, a database of
 DICOM objects, support for display of directories, images, reports and
 spectra, and DICOM object validation.
 .
 This package contains the JPEG selective block redaction codec as well
 as the jpegparse command line tool.

Package: libpixelmed-imageio-java
Architecture: all
Section: java
Depends: ${java:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: JPEG lossless decoder for pixelmed
 Pixelmed is a stand-alone DICOM toolkit that implements code for reading
 and creating DICOM data, DICOM network and file support, a database of
 DICOM objects, support for display of directories, images, reports and
 spectra, and DICOM object validation.
 .
 This package contains the JPEG lossless decoder.

=== debian/rules ===
--- 
+++ 
@@ -5,3 +5,16 @@
 
 %:
 	dh $@ --with javahelper
+
+override_dh_clean:
+	dh_clean BUILDDATE
+
+override_dh_install: debian/jpegparse.1
+	dh_install debian/jpegparse $(DESTDIR)/usr/bin/
+
+include /usr/share/dpkg/default.mk
+
+debian/jpegparse.1: debian/jpegparse.1.in
+	help2man --include=$< --output=$@ \
+		--name="JPEG parse program" --no-discard-stderr \
+		--no-info debian/`basename $@ .1` --version-string=$(DEB_SOURCE)

=== debian/watch ===
version=4
opts="downloadurlmangle=s:(\d+)_current/index.html:$1_current/pixelmedjavacodec_sourcerelease.$1.tar.bz2:g, \
 filenamemangle=s:^http.*/software/.*/(\d+)_current/index.html:pixelmed-codec_$1.tar.bz2:" \
 https://www.dclunie.com/pixelmed/software/codec/index.html ./(\d+)_current/index.html
